%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                   %
% Implementation of BAG's specification in LL using SELLF           %
%                                                                   %
% Author: Giselle Machado N. Reis                                   %
%                                                            2010   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

module bag.
accumulate sellf.

bag P :-
    sellf ((k_elm def (
                (sigma T\ sigma L\ sigma Prog\ 
                    (my_not (cmd (load T L Prog)) , ((? L T) @ ((cmd Prog) , true))))::
                (sigma L\ sigma Prog\
                    (my_not (cmd (unload L Prog)) , 
                        (sigma T\ (at L (my_not T) , ((cmd (Prog T)) @ bottom)))))::
                (sigma L\ sigma Prog\
                    (my_not (cmd (unload2 L Prog)) , 
                        (sigma X\ sigma Y\ (at L (my_not [X,Y]) , ((cmd (Prog X Y)) @ bottom)))))::
                (sigma C\ sigma Prog1\ sigma Prog2\
                    (my_not (cmd (while C Prog1 Prog2)) , 
                        ((C , ((cmd (Prog1 (while C Prog1 Prog2))) @ bottom)) ; (not C , ((cmd Prog2) @ bottom)))))::
                (sigma I\ sigma Kprog\ sigma Prog\
                    (my_not (cmd (loop I Kprog Prog)) , 
                        ( (sigma X\ (at I (my_not X) , (cmd (Kprog X (loop I Kprog Prog))))) ; bang_empty I (cmd Prog) )))::
                (sigma I\ sigma Kprog\ sigma Prog\
                    (my_not (cmd (loop2 I Kprog Prog)) , 
                        ( (sigma X\ sigma Y\ ((at I (my_not [X,Y]) , (cmd (Kprog X Y (loop2 I Kprog Prog)))))) ; bang_empty I (cmd Prog) )))::
                (sigma Prog1\ sigma Prog2\
                    (my_not (cmd (Prog1 alt Prog2)) , ((cmd Prog1) ; (cmd Prog2))))::
                (sigma C\ sigma Prog1\ sigma Prog2\ sigma Cont\
                    (my_not (cmd (if C Prog1 Prog2 Cont)) , 
                        ((C , ((cmd (Prog1 Cont)) @ bottom)) ; (not C , ((cmd (Prog2 Cont)) @ bottom)))))::
                (sigma L\ sigma Prog1\ sigma Prog2\ sigma Cont\
                    (my_not (cmd (if_is_empty L Prog1 Prog2 Cont)) , 
                        (bang_empty L (cmd (Prog1 Cont)) ; (sigma X\ (at L X) @ ((cmd (Prog2 Cont)) @ bottom)))))::
                (sigma L\ sigma Prog\
                    (my_not (cmd (new L Prog)) , (create L (cmd Prog))))::
                    (my_not (cmd done) , top)::
                nil
            %))::(k_elm l1 (2::1::9::0::6::3::nil))::(k_elm l2 nil)::(k_elm l3 nil)::nil)
            ))::(k_elm l1 ([1,4]::[2,3]::[3,2]::[4,1]::nil))::(k_elm l2 nil)::(k_elm l3 nil)::nil)
            nil
            (cmd(P)::nil).

%% Polarity
neg (cmd A).

%% Subexponentials
cont def.
weak def.

%%%% Subexponential indexes

weak i1.
weak i2.
weak i3.
weak i4.

cont i3.
cont i4.

pred l1 l2.
pred l2 l3.
pred i1 i2.
pred i2 i3.
pred i3 i4.

pred i1 i1.
pred i1 i3.
pred i1 i4.
pred i2 i2.
pred i2 i4.
pred i3 i3.
pred i4 i4.
pred l1 l1.
pred l1 l3.
pred l2 l2.
pred l3 l3.


