%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                   %
% Implementation of BAG's specification in LL using SELLF           %
% Signature file.                                                   %
%                                                                   %
% Author: Giselle Machado N. Reis                                   %
%                                                            2010   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

sig bag.
accum_sig sellf.

kind prog type.

%% Predicates

type bag prog -> o.
type cmd prog -> o.

%% Commands

type load           T -> index -> prog -> prog.
type unload         index -> (T -> prog) -> prog.
type unload2        index -> (T -> T -> prog) -> prog.
type while          o -> (prog -> prog) -> prog -> prog.
type loop           index -> (T -> prog -> prog) -> prog -> prog.
type loop2          index -> (T -> T -> prog -> prog) -> prog -> prog.
type alt            prog -> prog -> prog.
type if             o -> (prog -> prog) -> (prog -> prog) -> prog -> prog.
type if_is_empty    index -> (prog -> prog) -> (prog -> prog) -> prog -> prog.
type new            index -> prog -> prog.
type done           prog.

infixl alt 9.

%% Subexponentials
type def index.
type i1 index.
type i2 index.
type i3 index.
type i4 index.

type l1 index.
type l2 index.
type l3 index.
type l4 index.
type visited index.
type edges index.


