#!/bin/sh

echo "\n-------- Compiling SELLF"
tjcc sellf

echo "\n-------- Commands' tests: running all\n"

echo "[LOAD]\n"
tjsim -b sellf -s "prove_s ((k_elm l1 nil)::nil) nil (load a l1 done)." > proofs/load_def_1.txt
tjsim -b sellf -s "prove_s ((k_elm i3 nil)::nil) nil (load a i3 done)." > proofs/load_def_2.txt 

echo "[UNLOAD]\n"
tjsim -b sellf -s "prove_s ((k_elm l1 (a::b::nil))::nil) nil (unload l1 b done)." > proofs/unload_def_1.txt
tjsim -b sellf -s "prove_s ((k_elm i3 (a::b::nil))::nil) nil (unload i3 b done)." > proofs/unload_def_2.txt

#echo "[WHILE]\n"
#tjsim -b sellf -s "" > proofs/

echo "[LOOP]\n"
tjsim -b sellf -s "prove_s ((k_elm l1 (a::b::nil))::(k_elm l2 nil)::nil) nil (loop l1 (X\(load X l2)) done)." > proofs/loop_def.txt

echo "[ALT]\n"
tjsim -b sellf -s "prove_s ((k_elm l1 nil)::nil) nil ((unload l1 a done) alt (load b l1 done))." > proofs/alt_def.txt

echo "[IF_IS_EMPTY]\n"
tjsim -b sellf -s "prove_s ((k_elm l1 nil)::nil) nil (if_is_empty l1 (load a l1) (unload l1 a) done)." > proofs/if_is_empty_def_1.txt
tjsim -b sellf -s "prove_s ((k_elm l1 (b::nil))::nil) nil (if_is_empty l1 (load a l1) (unload l1 b) done)." > proofs/if_is_empty_def_2.txt

echo "[IF]\n"
tjsim -b sellf -s "prove_s ((k_elm l1 nil)::nil) nil (if (0 > 1) (load a l1) (load b l1) done)." > proofs/if_def.txt

echo "[NEW]\n"
tjsim -b sellf -s "prove_s nil nil (new l1 done)." > proofs/new_def.txt

echo "[END]\n"
tjsim -b sellf -s "prove_s nil nil done." > proofs/end_def.txt

