%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                   %
% Implementation of LU's specification in LL using SELLF            %
% Signature file.                                                   %
%                                                                   %
% Author: Giselle Machado N. Reis                                   %
%                                                            2010   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

sig lu.
accum_sig sellf.

kind form type.

%% Predicates

type lu             list form -> list form -> o.
type atomize_left   list form -> list o -> o.
type atomize_right  list form -> list o -> o.

%% Meta-level predicates

type bd         form -> o.
type bu         form -> o.
type neg_lu     form -> o.
type pos_lu     form -> o.
type neu_lu     form -> o.
type nneg_lu    form -> o.
type npos_lu    form -> o.
type nneu_lu    form -> o.

%% Connectives

type i_imp    form -> form -> form.
type c_imp    form -> form -> form.
type and      form -> form -> form.
type or       form -> form -> form.
type forall   (A -> form) -> form.
type exists   (A -> form) -> form.
type one_lu   form.
type zero_lu  form.

infix i_imp 8.
infix c_imp 7.
infix and   6.
infix or    4.

%% Elements
% Pretending this is LL without subexponentials

type cl index.

type a form.
type b form.
type c form.
type d form.
type e form.
type p form.




