%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                  %
%   THEOREM 31 - Automated proof   %
%                                  %
%   Giselle Machado N. Reis        %
%                                  %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

module theorem31.
accumulate sellf.

%% Use ¬Bl and ¬Br as parameters of the predicate dual,
%% since the negation may only be applied to atoms in 
%% this system.

dual Bl Br :-
    sellf ((k_elm cl (
                % Initial
                (sigma B\ ((my_not (bd B)) , (my_not (bu B)))):: 
                % Cut
                (sigma B\ ((bd B) , (bu B))):: 
                % Neg
                (sigma N\ ((my_not (bu N)) , (? cl (bu N)) , (bang cl (neg_lu N)))):: 
                % Pos
                (sigma P\ ((my_not (bd P)) , (? cl (bd P)) , (bang cl (pos_lu P)))):: 
                % Conjunction right 1
                %(sigma A\ sigma B\ ((my_not (bu (A and B))) , 
                %                    (bang cl (bu A)) , (bang cl (bu B)) , 
                %                    (bang cl ((pos_lu A) ; (pos_lu B))) )):: 
                % Conjunction right 2                    
                %(sigma A\ sigma B\ ((my_not (bu (A and B))) , 
                %                    ((bu A) & (bu B)) , 
                %                    (bang cl ((npos_lu A) & (npos_lu B))) ))::
                % Conjunction left 1
                %(sigma A\ sigma B\ ((my_not (bd (A and B))) , 
                %                    ((? cl (bd A)) @ (? cl (bd B))) , 
                %                    (bang cl ((pos_lu A) ; (pos_lu B))) )):: 
                % Conjunction left 2
                %(sigma A\ sigma B\ ((my_not (bd (A and B))) , 
                %                    ((bd A) ; (bd B)) , 
                %                    (bang cl ((npos_lu A) & (npos_lu B))) )):: 
                % Intuitionistic implication right
                %(sigma A\ sigma B\ ((my_not (bu (A i_imp B))) , ((? cl (bd A)) @ (bu B)) ))::
                % Intuitionistic implication left
                %(sigma A\ sigma B\ ((my_not (bd (A i_imp B))) , ((bang cl (bu A)) , (bd B)) ))::
                % Forall right
                %(sigma A\ ((my_not (bu (forall A))) , (pi x\ (bang cl (bu (A x)))) ))::
                % Forall left
                %(sigma A\ ((my_not (bd (forall A))) , (bang cl (bd (A X))) ))::
                % Exists right
                %(sigma A\ ((my_not (bu (exists A))) , (bang cl (bu (A X))) ))::
                % Exists left
                %(sigma A\ ((my_not (bd (exists A))) , (pi x\ (bang cl (bd (A x)))) ))::
                % Disjunction right 1
                %(sigma A\ sigma B\ ((my_not (bu (A or B))) , 
                %                    ((bang cl (bu A)) ; (bang cl (bu B))) , 
                %                    (bang cl ((nneg_lu A) & (nneg_lu B))) ))::
                % Disjunction right 2
                %(sigma A\ sigma B\ ((my_not (bu (A or B))) , 
                %                    ((? cl (bu A)) @ (? cl (bu B))) , 
                %                    (bang cl (((pos_lu A) & (neg_lu B)) ; ((neg_lu A) & (nneu_lu B)))) ))::
                % Disjunction right 3
                %(sigma A\ sigma B\ ((my_not (bu (A or B))) , 
                %                    ((bu A) @ (? cl (bang cl (bu B)))) , 
                %                    (bang cl ((neg_lu A) & (neu_lu B))) ))::
                % Disjunction right 4
                %(sigma A\ sigma B\ ((my_not (bu (A or B))) , 
                %                    ((? cl (bang cl (bu A))) @ (bu B)) , 
                %                    (bang cl ((neu_lu A) & (neg_lu B))) ))::
                % Disjunction left 1
                %(sigma A\ sigma B\ ((my_not (bd (A or B))) , 
                %                    ((? cl (bd A)) & (? cl (bd B))) , 
                %                    (bang cl ((nneg_lu A) & (nneg_lu B))) ))::
                % Disjunction left 2
                %(sigma A\ sigma B\ ((my_not (bd (A or B))) , 
                %                    ((bang cl (bd A)) , (bang cl (bd B))) ,
                %                    (bang cl (((pos_lu A) & (neg_lu B)) ; ((neg_lu A) & (nneu_lu B)))) ))::
                % Disjunction left 3
                %(sigma A\ sigma B\ ((my_not (bd (A or B))) , 
                %                    ((bd A) , (bang cl (? cl (bd B)))) ,
                %                    (bang cl ((neg_lu A) & (neu_lu B))) ))::
                % Disjunction left 4
                %(sigma A\ sigma B\ ((my_not (bd (A or B))) , 
                %                    ((bang cl (? cl (bd A))) , (bd B)) ,
                %                    (bang cl ((neu_lu A) & (neg_lu B))) ))::
                % Classical implication right 1
                %(sigma A\ sigma B\ ((my_not (bu (A c_imp B))) , 
                %                    ((? cl (bd A)) @ (? cl (bu B))) , 
                %                    (bang cl (((neg_lu A) & (neg_lu B)) ; ((pos_lu A) & (nneu_lu B)))) ))::
                % Classical implication right 2
                %(sigma A\ sigma B\ ((my_not (bu (A c_imp B))) , 
                %                    ((bu B) ; (bd A)) , 
                %                    (bang cl ((neg_lu A) & (pos_lu B))) ))::
                % Classical implication left 1
                %(sigma A\ sigma B\ ((my_not (bd (A c_imp B))) , 
                %                    ((bu A) & (bd B)) , 
                %                    (bang cl ((neg_lu A) & (pos_lu B))) ))::
                % Classical implication left 2
                %(sigma A\ sigma B\ ((my_not (bd (A c_imp B))) , 
                %                    ((bang cl (bu A)) , (bang cl (bd B))) , 
                %                    (bang cl (((neg_lu A) & (neg_lu B)) ; ((pos_lu A) & (nneu_lu B)))) ))::
                % Polarities
                %(sigma A\ ((my_not (npos_lu A)) , ((neu_lu A) ; (neg_lu A)) ))::
                %(sigma A\ ((my_not (nneg_lu A)) , ((neu_lu A) ; (pos_lu A)) ))::
                %(sigma A\ ((my_not (nneu_lu A)) , ((neg_lu A) ; (pos_lu A)) ))::
                % Uniqueness of polarities for formulas
                (sigma A\ ((pos_lu A) , (neg_lu A) , top))::
                (sigma A\ ((pos_lu A) , (neu_lu A) , top))::
                (sigma A\ ((neg_lu A) , (neu_lu A) , top))::
                nil)
             )::nil
            )
            nil
            (((Bl @ Br))::nil).

%% Polarity

neg (bd X).
neg (bu X).

% Subexponentials
            
cont cl.
weak cl.

pred cl cl.
            


