%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                   %
% Implementation of MLJ's specification in LL using SELLF           %
% Signature file.                                                   %
%                                                                   %
% Author: Giselle Machado N. Reis                                   %
%                                                            2010   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

sig mlj.
accum_sig sellf.

kind form type.

%% Predicates

type mlj (list form) -> (list form) -> o.
type atomize_left (list form) -> list o -> o.
type atomize_right list form -> list o -> o.

%% Brackets down and up

type bd form -> o.
type bu form -> o.

%% Connectives

type imp    form -> form -> form.
type and    form -> form -> form.
type or     form -> form -> form.
type forall (form -> form) -> form.
type exists (form -> form) -> form.
type btm    form.

infix imp 8.
infix and 6.
infix or  4.

%% Elements

type r index.
type l index.
type rules index.

type a form.
type b form.
type c form.
type d form.
type e form.
type f form.
type g form.
type h form.
type p form.




